困难版单词接龙
Posted awangkuo
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了困难版单词接龙相关的知识,希望对你有一定的参考价值。
给定两个单词(beginWord 和 endWord)和一个字典 wordList,找出所有从 beginWord 到 endWord 的最短转换序列。转换需遵循如下规则:
每次转换只能改变一个字母。
转换过程中的中间单词必须是字典中的单词。
说明:
如果不存在这样的转换序列,返回一个空列表。
所有单词具有相同的长度。
所有单词只由小写字母组成。
字典中不存在重复的单词。
你可以假设 beginWord 和 endWord 是非空的,且二者不相同。
示例 1:
输入:
beginWord = "hit",
endWord = "cog",
wordList = ["hot","dot","dog","lot","log","cog"]
输出:
[
["hit","hot","dot","dog","cog"],
["hit","hot","lot","log","cog"]
]
示例 2:
输入:
beginWord = "hit"
endWord = "cog"
wordList = ["hot","dot","dog","lot","log"]
输出: []
解释: endWord "cog" 不在字典中,所以不存在符合要求的转换序列。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/word-ladder-ii
解题思路:
本题要求的是最短转换序列,看到最短首先想到的就是 BFS。想到 BFS 自然而然的就能想到图,但是本题并没有直截了当的给出图的模型,因此我们需要把它抽象成图的模型。
我们可以把每个单词都抽象为一个点,如果两个单词可以只改变一个字母进行转换,那么说明他们之间有一条双向边。因此我们只需要把满足转换条件的点相连,就形成了一张图。
最后问题就巧妙的抽象转化为在双向图中寻找最短路径,代码实现如下:
const int INF = 1 << 20; class Solution { private: unordered_map<string, int> wordId; vector<string> idWord; vector<vector<int>> edges; public: vector<vector<string>> findLadders(string beginWord, string endWord, vector<string>& wordList) { int id = 0; for (const string& word : wordList) { if (!wordId.count(word)) { wordId[word] = id++; idWord.push_back(word); } } if (!wordId.count(endWord)) { return {}; } if (!wordId.count(beginWord)) { wordId[beginWord] = id++; idWord.push_back(beginWord); } edges.resize(idWord.size()); for (int i = 0; i < idWord.size(); i++) { for (int j = i + 1; j < idWord.size(); j++) { if (transformCheck(idWord[i], idWord[j])) { edges[i].push_back(j); edges[j].push_back(i); } } } const int dest = wordId[endWord]; vector<vector<string>> res; queue<vector<int>> q; vector<int> cost(id, INF); q.push(vector<int>{wordId[beginWord]}); cost[wordId[beginWord]] = 0; while (!q.empty()) { vector<int> now = q.front(); q.pop(); int last = now.back(); if (last == dest) { vector<string> tmp; for (int index : now) { tmp.push_back(idWord[index]); } res.push_back(tmp); } else { for (int i = 0; i < edges[last].size(); i++) { int to = edges[last][i]; if (cost[last] + 1 <= cost[to]) { cost[to] = cost[last] + 1; vector<int> tmp(now); tmp.push_back(to); q.push(tmp); } } } } return res; } bool transformCheck(const string& str1, const string& str2) { int differences = 0; for (int i = 0; i < str1.size() && differences < 2; i++) { if (str1[i] != str2[i]) { ++differences; } } return differences == 1; } };
以上是关于困难版单词接龙的主要内容,如果未能解决你的问题,请参考以下文章